unit MIDIDRV;

interface
const
  mtGENERAL  = 0;
  mtEXTENDED = 1;
  mtBASIC    = 2;

Var MPort : Word;
    DPort : Word;
    DIrq,DDma : Byte;
    MNum : Word;
    MMax : Word;

{$L MIDI}

const
  SBlastBase: Word = $220;

  Procedure PlayMIDI;
  Procedure CheckMIDI;
  Procedure MIDIDone;

  procedure MIDIInit( MIDIType: Word);
  procedure MIDIUnInit;

  procedure MIDISetPort( Port, Device: Word);
  procedure MIDIPlay( MIDI: Pointer );
  procedure MIDIStop;

  function  MIDIStatus: Word;

implementation

Uses PlayDig;

procedure MIDIInit( MIDIType: Word); external;
procedure MIDIUnInit; external;

procedure MIDISetPort( Port, Device: Word); external;
procedure MIDIPlay( MIDI: Pointer ); external;
procedure MIDIStop; external;

function  MIDIStatus: Word; external;

Var F : File;
Ch : Array[1..3] of Char;

Const LibHeader : Array[1..3] of Char = ('M','I','D');

Procedure CheckMIDI;
Begin
  If MPort=0 then Exit;
  If MIDIStatus=0 then
  Begin
    Inc(MNum);
    If MNum>MMax-1 then MNum:=0;
    PlayMIDI;
  End;
End;

Var MidiBuf : Pointer;

Procedure PlayMIDI;
Var O,S : LongInt;
Begin
  If MPort=0 then Exit;
  Assign(F,'music.lab');
  ReSet(F,1);
  Seek(F,MNum*8+4);
  BlockRead(F,O,4);
  BlockRead(F,S,4);
  Seek(F,O);
  BlockRead(F,MidiBuf^,S);
  Close(F);
  MIDIPlay(MidiBuf);
End;

Procedure MIDIDone;
Begin
  if MPort<>0 then
  Begin
    MidiUnInit;
    FreeMem(MidiBuf,64000);
  End;
End;

Var MOn,DOn : Boolean;

begin
  Assign(F,'music.lab');
  ReSet(F,1);
  BlockRead(F,MMax,2);
  Close(F);
  Assign(F,'labirint.exe');
  ReSet(F,1);
  Seek(F,FileSize(F)-9);
  BlockRead(F,Ch,3);
  MPort:=$220;
  MOn:=True;
  If Ch=LibHeader then Begin BlockRead(F,MPort,2);BlockRead(F,MOn,1); End else MOn:=True;
  If MOn then
  Begin
    GetMem(MidiBuf,64000);
    MIDISetPort(MPort,0);
    MIDIInit(MTGeneral);
  End;
  If Ch=LibHeader then
  Begin
    BlockRead(F,DOn,1);
    If DOn then DPort:=MPort else DPort:=0;
    BlockRead(F,DIrq,1);
    BlockRead(F,DDma,1);
  End else
  Begin
    DPort:=$220;
    DOn:=True;
    DIrq:=5;
    DDma:=1;
  End;
  If Not MOn then MPort:=0;
  InitDigital(DPort,DIrq,DDma);
  Close(F);
end.
