Unit Svga;
{$L font}
{$L stdpal}

Interface

Const
      PalMask = $36C;
      PalRegR = $3C7;
      PalRegW = $3C8;
      PalData = $3C9;

      FadeSpeed = 40;

Type
     TPalette = Array[0..255] of record R,G,B : Byte; End;
     TWord = Array[0..30000] of Word;
     TFont = Array[0..255,0..103] of Byte; { 8x14 }
     VesaInfo = record
       Sign : Array[1..4] of Char;
       Version : Word;
       OEM : Pointer;
       Capabilities : LongInt;
       ModeList : ^TWord;
       TotalMemory : Word;
       Reserved : Array[1..236] of Byte;
     End;
     VESAModeInfo = record
       ModeAttributes : Word;
       WinAAttributes,WinBAttributes : Byte;
       WinGranularity,WinSize : Word;
       WinASegment,WinBSegment : Word;
       WinFuncPrt : Procedure;
       BytesPerScanLine : Word;
       XResolution : Word;
       YResolution : Word;
       XCharSize : Byte;
       YCharSize : Byte;
       NumberOfPlanes : Byte;
       BitsPerPixel : Byte;
       NumberOfBanks : Byte;
       MemoryModel : Byte;
       BankSize : Byte;
       NumberOfPages : Byte;
       Reserved : Byte;
       RedMaskSize : Byte;
       RedFieldPosition : Byte;
       GreenMaskSize : Byte;
       GreenFieldPosition : Byte;
       BlueMaskSize : Byte;
       BlueFieldPosition : Byte;
       RsvdMaskSize : Byte;
       RsvdFieldPosition : Byte;
       DirectColorModeInfo : Byte;
       Reserved2 : Array[1..216] of Byte;
     End;
     Long = record Low,Hi : Word; End;

Var Gran : Word;
    CurBank : Word;
    Timer : LongInt absolute $40:$6c;
    Fnt : ^TFont;
    CurPal : TPalette;

Procedure InitSvga;
Procedure DoneSvga;
Procedure SetVesaBank(Start : Word);
Procedure Cls(Color : Byte);
Procedure SetPalReg(index,Red,Green,Blue : Byte);
Procedure GetPalReg(index : Byte; Var Red,Green,Blue : Byte);
Procedure SetPalette(Pal : TPalette);
Procedure ShowLine(Line : Pointer;Size,X,Y : Word);
Procedure ShowImage(Image : Pointer;X,Y,W,H : Word);
Procedure ShowTransLine(Line : Pointer;Size,X,Y : Word);
Procedure ShowTrans(Image : Pointer;X,Y,W,H : Word);
Procedure ShowSprLine(Line : Pointer;Size,X,Y : Word;Color : Byte);
Procedure ShowSpr(Image : Pointer;X,Y,W,H : Word;Color : Byte);
Procedure GetLine(Line : Pointer;Size,X,Y : Word);
Procedure GetImage(Image : Pointer;X,Y,W,H : Word);
Function GetPixel(X,Y : Word) : Byte;
Procedure PutPixel(X,Y : Word;Col : Byte);
Procedure Print(S : String;X,Y : Word;Col : Byte);
Procedure FadePal(Pal : TPalette);
Procedure LightPal(Pal : TPalette);

Implementation

Procedure FONT; far; external;
Procedure StdPal; far; external;

Procedure Print(S : String;X,Y : Word;Col : Byte);
Var A : LongInt;
B : Byte;
P : Pointer;
Begin
  For B:=1 to Length(S) do
  Begin
    P:=Ptr(Seg(Fnt^),Ofs(Fnt^)+Word(Byte(S[B])-1)*104);
    ShowSpr(P,X+(B-1) shl 3,Y,8,13,Col);
{    Asm
      push ds
      mov ax,$A000
      mov es,ax
      mov di,Word(A)
      add di,7
      lds si,P
      mov cx,13
      @1:
      push cx
      mov cx,8
      @2:
      mov al,[si]
      or al,al
      jz @3
      mov al,col
      @3:
      mov es:[di],al
      dec di
      inc si
      loop @2
      pop cx
      add di,648
      loop @1
      pop ds
    End;
    Inc(A,8);}
  End;
End;

Function GetPixel(X,Y : Word) : Byte;
Var A : LongInt;
Begin
  A:=(LongInt(Y) shl 9)+(LongInt(Y) shl 7)+LongInt(X);
  SetVesaBank(Long(A).Hi);
  GetPixel:=Mem[$A000:Word(A)];
End;

Procedure PutPixel(X,Y : Word;Col : Byte);
Var A : LongInt;
Begin
  A:=(LongInt(Y) shl 9)+(LongInt(Y) shl 7)+LongInt(X);
  SetVesaBank(Long(A).Hi);
  Mem[$A000:Word(A)]:=Col;
End;

Procedure ShowLine(Line : Pointer;Size,X,Y : Word);
Var A : LongInt;
Begin
  A:=(LongInt(Y) shl 9)+(LongInt(Y) shl 7)+LongInt(X);
  SetVesaBank(Long(A).Hi);
  If (65535-Word(A)<Size) then
  asm
    mov ax,$A000
    mov es,ax
    push ds
    mov di,Word(A)
    lds si,Line
    mov ax,Word(A)
    mov cx,$FFFF
    sub cx,ax
    inc cx
    rep movsb
    mov ax,ds
    pop ds
    push ax
    mov ax,Long(A).Hi
    inc ax
    push si
    push ax
    call SetVesaBank
    pop si
    mov ax,ds
    pop ds
    push ax
    mov cx,Word(A)
    mov ax,$FFFF
    sub ax,cx
    mov cx,size
    sub cx,ax
    xor di,di
    rep movsb
    pop ds
  End else
  Asm
    mov ax,$A000
    mov es,ax
    mov di,Word(A)
    push ds
    lds si,Line
    mov cx,Size
    rep movsb
    pop ds
  End;
End;

Procedure ShowImage(Image : Pointer;X,Y,W,H : Word);
Var A : Word;
Begin
  For A:=0 to H-1 do
    ShowLine(Ptr(Seg(Image^),Ofs(Image^)+A*W),W,X,Y+A);
End;

Procedure ShowTransLine(Line : Pointer;Size,X,Y : Word);
Var A : LongInt;
Begin
  A:=(LongInt(Y) shl 9)+(LongInt(Y) shl 7)+LongInt(X);
  SetVesaBank(Long(A).Hi);
  If (65535-Word(A)<Size) then
  asm
    mov ax,$A000
    mov es,ax
    push ds
    mov di,Word(A)
    lds si,Line
    mov ax,Word(A)
    mov cx,$FFFF
    sub cx,ax
    inc cx
    @1:
    mov al,[si]
    or al,al
    jz @2
    mov es:[di],al
    @2:
    inc di
    inc si
    dec cx
    jnz @1
    mov ax,ds
    pop ds
    push ax
    mov ax,Long(A).Hi
    inc ax
    push si
    push ax
    call SetVesaBank
    pop si
    mov ax,ds
    pop ds
    push ax
    mov cx,Word(A)
    mov ax,$FFFF
    sub ax,cx
    mov cx,size
    sub cx,ax
    xor di,di
    @3:
    mov al,[si]
    or al,al
    jz @4
    mov es:[di],al
    @4:
    inc di
    inc si
    dec cx
    jnz @3
    pop ds
  End else
  Asm
    mov ax,$A000
    mov es,ax
    mov di,Word(A)
    push ds
    lds si,Line
    mov cx,Size
    @1:
    mov al,[si]
    or al,al
    jz @2
    mov es:[di],al
    @2:
    inc di
    inc si
    dec cx
    jnz @1
    pop ds
  End;
End;

Procedure ShowTrans(Image : Pointer;X,Y,W,H : Word);
Var A : Word;
Begin
  For A:=0 to H-1 do
    ShowTransLine(Ptr(Seg(Image^),Ofs(Image^)+A*W),W,X,Y+A);
End;

Procedure ShowSprLine(Line : Pointer;Size,X,Y : Word;Color : Byte);
Var A : LongInt;
Begin
  A:=(LongInt(Y) shl 9)+(LongInt(Y) shl 7)+LongInt(X);
  SetVesaBank(Long(A).Hi);
  If (65535-Word(A)<Size) then
  asm
    mov ax,$A000
    mov es,ax
    push ds
    mov di,Word(A)
    lds si,Line
    mov ax,Word(A)
    mov cx,$FFFF
    sub cx,ax
    inc cx
    @1:
    mov al,[si]
    or al,al
    jz @2
    cmp al,1
    jnz @n1
    mov al,color
    @n1:
    mov es:[di],al
    @2:
    inc di
    inc si
    dec cx
    jnz @1
    mov ax,ds
    pop ds
    push ax
    mov ax,Long(A).Hi
    inc ax
    push si
    push ax
    call SetVesaBank
    pop si
    mov ax,ds
    pop ds
    push ax
    mov cx,Word(A)
    mov ax,$FFFF
    sub ax,cx
    mov cx,size
    sub cx,ax
    xor di,di
    @3:
    mov al,[si]
    or al,al
    jz @4
    cmp al,1
    jnz @n2
    mov al,color
    @n2:
    mov es:[di],al
    @4:
    inc di
    inc si
    dec cx
    jnz @3
    pop ds
  End else
  Asm
    mov ax,$A000
    mov es,ax
    mov di,Word(A)
    push ds
    lds si,Line
    mov cx,Size
    @1:
    mov al,[si]
    or al,al
    jz @2
    cmp al,1
    jnz @n1
    mov al,color
    @n1:
    mov es:[di],al
    @2:
    inc di
    inc si
    dec cx
    jnz @1
    pop ds
  End;
End;

Procedure ShowSpr(Image : Pointer;X,Y,W,H : Word;Color : Byte);
Var A : Word;
Begin
  For A:=0 to H-1 do
    ShowSprLine(Ptr(Seg(Image^),Ofs(Image^)+A*W),W,X,Y+A,Color);
End;


Procedure GetLine(Line : Pointer;Size,X,Y : Word);
Var A : LongInt;
Begin
  A:=(LongInt(Y) shl 9)+(LongInt(Y) shl 7)+LongInt(X);
  SetVesaBank(Long(A).Hi);
  If (65535-Word(A)<Size) then
  asm
    push ds
    mov ax,$A000
    mov ds,ax
    mov si,Word(A)
    les di,Line
    mov ax,Word(A)
    mov cx,$FFFF
    sub cx,ax
    inc cx
    rep movsb
    pop ds
    push es
    mov ax,Long(A).Hi
    inc ax
    push di
    push ax
    call SetVesaBank
    pop di
    pop es
    push ds
    mov ax,$A000
    mov ds,ax
    mov cx,Word(A)
    mov ax,$FFFF
    sub ax,cx
    mov cx,size
    sub cx,ax
    xor si,si
    rep movsb
    pop ds
  End else
  Asm
    mov ax,$A000
    push ds
    mov ds,ax
    mov si,Word(A)
    les di,Line
    mov cx,Size
    rep movsb
    pop ds
  End;
End;

Procedure GetImage(Image : Pointer;X,Y,W,H : Word);
Var A : Word;
Begin
  For A:=0 to H-1 do
    GetLine(Ptr(Seg(Image^),Ofs(Image^)+A*W),W,X,Y+A);
End;

Procedure Cls(Color : Byte);
Var A : LongInt;
    B : Word;
Begin
  A:=640*480;
  B:=0;
  Repeat
    SetVesaBank(B);
    If A>65536 then
    asm
      mov ax,$A000
      mov es,ax
      mov cx,32768
      xor di,di
      mov al,color
      mov ah,al
      rep stosw
    end else
    asm
      mov ax,$A000
      mov es,ax
      mov cx,Word(a)
      xor di,di
      mov al,color
      mov ah,al
      rep stosw
    end;
    Inc(B);
    Dec(A,65536);
  Until A<=0;
End;

Procedure SetPalReg(index,Red,Green,Blue : Byte);
Begin
  Port[PalMask]:=$FF;
  Port[PalRegW]:=index;
  Port[PalData]:=Red;
  Port[PalData]:=Green;
  Port[PalData]:=Blue;
End;

Procedure GetPalReg(index : Byte; Var Red,Green,Blue : Byte);
Begin
  Port[PalMask]:=$FF;
  Port[PalRegR]:=index;
  Red:=Port[PalData];
  Green:=Port[PalData];
  Blue:=Port[PalData];
End;

Procedure SetPalette(Pal : TPalette);
Var A : Byte;
Begin
  For A:=0 to 255 do SetPalReg(A,Pal[A].R,Pal[A].G,Pal[A].B);
End;

Procedure FadePal(Pal : TPalette);
Var A,B : LongInt;
P : TPalette;
T : LongInt;
Begin
  For B:=FadeSpeed downto 0 do
  Begin
    For A:=0 to 255 do
    Begin
      P[A].R:=Trunc(Pal[A].R*B/FadeSpeed);
      P[A].G:=Trunc(Pal[A].G*B/FadeSpeed);
      P[A].B:=Trunc(Pal[A].B*B/FadeSpeed);
    End;
    SetPalette(P);
    T:=MemL[$40:$6c];
    Repeat Until MemL[$40:$6c]-T>=1;
  End;
End;

Procedure LightPal(Pal : TPalette);
Var A,B : LongInt;
P : TPalette;
T : LongInt;
Begin
  For B:=0 to FadeSpeed do
  Begin
    For A:=0 to 255 do
    Begin
      P[A].R:=Trunc(Pal[A].R*B/FadeSpeed);
      P[A].G:=Trunc(Pal[A].G*B/FadeSpeed);
      P[A].B:=Trunc(Pal[A].B*B/FadeSpeed);
    End;
    SetPalette(P);
    T:=MemL[$40:$6c];
    Repeat Until MemL[$40:$6c]-T>=1;
  End;
End;

Function FindVesa(Var Vi : VesaInfo) : Boolean;
Var A : Word;
Begin
  Asm
    Push es
    Push di
    les di,DWord(Vi)
    Mov ax,$4F00
    Int $10
    Pop di
    Pop es
    Mov A,ax
  End;
  If A<>$004F then FindVesa:=False else
    If Vi.Sign='VESA' then FindVesa:=True else
      FindVesa:=False;
End;

Function FindVesaMode(Mode : Word;Var Mi : VesaModeInfo) : Boolean;
Var A : Word;
Begin
  Asm
    Push es
    Push di
    Les di,dword(Mi)
    Mov ax,$4F01
    Mov cx,Mode
    Int $10
    Pop di
    Pop es
    Mov A,ax
  End;
  FindVesaMode:=A=$004F;
End;

Procedure SetVesaBank(Start : Word);
Begin
  If Start=CurBank then Exit;
  CurBank:=Start;
  Start:=Start*Gran;
  Asm
    Mov ax,$4F05
    Mov bx,0
    Mov dx,Start
    Push dx
    Int $10
    Mov bx,1
    Pop dx
    Mov ax,$4F05
    Int $10
  End;
End;

Procedure InitSvga;
Var Vi : VESAInfo;
    Mi : VESAModeInfo;
    A : Word;
Begin
  If Not FindVesa(Vi) then
  Begin
    WriteLn('Sorry, your computer doesn"t support SVGA');
    Halt(1);
  End;
  If Not FindVesaMode($101,Mi) then { 640x480x256 }
  Begin
    WriteLn('Sorry, your computer doesn"t support 640x480x256 resolution');
    Halt(1);
  End;
  Gran:=64 div Mi.WinGranularity;
  Asm
    mov ax,$4F02
    mov bx,$101
    int $10
    mov a,ax
  End;
  If A<>$004F then
  Begin
    WriteLn('Error setting 640x480x256 resolution');
    Halt(1);
  End;
  CurBank:=$FFFF;
  SetVesaBank(0);
  Fnt:=@Font;
  CurPal:=TPalette(@stdpal^);
  SetPalette(CurPal);
End;

Procedure DoneSvga;
Begin
  asm
    mov ax,3
    int $10
  end;
End;

End.